#-*- coding: iso-8859-15 -*-

import sqlite3 as dbapi
import time
from language import *
import os, sys

class BD:
    """Creamos y definimos funciones para guardar y utilizar la base de datos"""
    def __init__(self):
        self.BD = dbapi.connect("Tiempos.dat")
        #creamos el cursor
        self.c = self.BD.cursor()
        #Creamos una tabla tiempos
        self.c.execute("""create table if not exists tiempos(id int PRIMARY KEY,\
         tipo FLOAT, tiempo FLOAT, fecha Timestamp)""")  #time(2) cent. de seg. --> hh:mm:ss.nn
        
    
    def guardar(self, tiempo, tipo):
        """guarda un tiempo en la base de datos, pasándole 
        como parámetros un tiempo y el tipo de cubo"""
        #añadir un nuevo tiempo detrás de los demás #TODO try id sea autonumérico
        self.c.execute('select * from tiempos')
        cont = len(self.c.fetchall()) + 1
        #fecha actual
        date = time.time()

        #insertamos datos dentro de la tabla
        self.c.execute('insert into tiempos values (%d,"%s","%f","%s")' % (cont,tipo,tiempo,date))

        #hacemos el commit para que todo lo anterior se ejecute de verdad :P
        self.BD.commit()
    
    
    ######### CONSULTAS #############    
    def consultarTodo(self):
        """Consulta la base de datos completa"""
        self.c.execute('select * from tiempos')
        for fila in self.c:
            Min = fila[2]/60
            Seg = fila[2]%60
            #tiempo
            tiempo = lll.time + "%02d:%05.2f" %(Min, Seg)
            #fecha
            fecha = lll.date + time.strftime('%H:%M:%S, %d-%b-%Y', time.localtime(fila[3]))
            print "%s %40s" % (tiempo, fecha)
            
            
    def consultarMediaDe(self,x = 5):
        """Consultar la media de los x ultimos números"""
        self.c.execute('select * from tiempos')
        if x > len(self.c.fetchall()):
            print lll.error5
        
        cont = x
        total = 0
        self.c.execute('select * from tiempos order by id DESC') #ordenar inversamente
        for tupla in self.c.fetchall():
            total += tupla[2]
            cont -=1
            if cont < 0: break
        
        #hacemos la media y creamos la cadena "00:00.00"
        total = total/x
        Min = total/60
        Seg = total%60
        print lll.avg + "%d: %02d:%05.2f" %(x, Min, Seg)
            
    
    def consultarRecord(self):
        """Consulta el mejor tiempo"""
        #ordenar ASC, DESC
        self.c.execute('select * from tiempos order by tiempo ASC') 
        for tupla in self.c.fetchall():
            tiempo = tupla[2]
            break
        Min = tiempo/60
        Seg = tiempo%60
        print lll.record + "%02d:%05.2f" %(Min, Seg)
        
            
    #TODO Cambiar todo antes de usar esto ;)
    def consultarTiemposDe(self, tipo):
        """Consulta los tiempos del tipo de cubo que le des en la entrada"""
        self.c.execute("""select * from tiempos where tipo='%s'""" % tipo)
        for tupla in self.c.fetchall():
            print tupla


    def close(self):
        """cerramos el cursor y la base de datos"""
        self.c.close()
        self.BD.close()




class statistic(BD): 
    """Esta clase utiliza las funciones de la clase BD para las estadisticas"""
    def __init__(self):
        bbdd = BD()
        while 1:
            sys.stdout.write(os.popen('clear').read())
            print lll.menu[4]
            opcion = raw_input(lll.statistic)
            
            if opcion == "2":
                try:
                    x = int(raw_input(lll.mediaDe))
                except:
                    x = 5
                bbdd.consultarMediaDe(x)
            elif opcion == "3": 
                bbdd.consultarRecord()
            elif opcion == "4":
                tipo = raw_input(lll.select) 
                bbdd.consultarTiemposDe(tipo)
            else:
                bbdd.consultarTodo()

            otraConsulta = raw_input(lll.consulta)
            yes = lll.yes 
            if yes.count(otraConsulta.lower()) <= 0:
                break

        bbdd.close()
